<?php
  /**************************************************************************\
  * Phenix Agenda                                                            *
  * http://phenix.gapi.fr                                                    *
  * Written by Stephane TEIL <phenix-agenda@laposte.net>                     *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

// ----------------------------------------------------------------------------
// Initialisation du style par defaut de l'application
@session_start();
$APPLI_STYLE = 0;
// ----------------------------------------------------------------------------
function SessionId($longueur, $idUser, $weekType) {
  global $DB_CX, $PREFIX_TABLE;

  $Pool  = "0123456789";
  $Pool .= "abcdefghijklmnopqrstuvwxyz";
  $Pool .= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  $ok = false;

  // Generation d'un identifiant unique
  while (!$ok) {
    $sid = "";
    for ($index = 0; $index < $longueur; $index++)
      $sid .= substr($Pool, (mt_rand()%(strlen($Pool))), 1);
    $DB_CX->DbQuery("SELECT sid_util_id FROM ${PREFIX_TABLE}sid WHERE sid_id='".$sid."'");
    $ok = ($DB_CX->DbNumRows() == 0);
  }

  // Enregistrement de la session
  $DB_CX->DbQuery("INSERT INTO ${PREFIX_TABLE}sid VALUES ('".$sid."', ".$idUser.", now(),'".@session_id()."',".$idUser.",'".$weekType."','ALL')");

  return ($sid);
}


// ----------------------------------------------------------------------------
function Session_ok($idSession) {
  global $DB_CX, $PREFIX_TABLE, $APPLI_STYLE, $DUREE_SESSION, $TELEPHONE_VF, $SEMAINE_TYPE, $tcMenu, $USER_SUBSTITUE, $FILTRE_COULEUR;

  // On supprime les sessions de plus de 1 heure
  $DB_CX->DbQuery("DELETE FROM ${PREFIX_TABLE}sid WHERE sid_last_maj < '".date("Y-m-d H:i:s", (time() - $DUREE_SESSION))."'");

  // On recherche les sessions encore valides
  $DB_CX->DbQuery("SELECT util_id, util_interface, util_telephone_vf, util_planning, sid_util_subst_id, sid_semaine_type, sid_filtre_couleur FROM ${PREFIX_TABLE}sid, ${PREFIX_TABLE}utilisateur WHERE sid_id='".$idSession."' AND sid_util_id = util_id AND sid_session_id='".@session_id()."'");

  if ($DB_CX->DbNumRows()) {
    // Recuperation de l'uid et du style
    $idUser = $DB_CX->DbResult(0,0);
    $APPLI_STYLE += $DB_CX->DbResult(0,1);
    $TELEPHONE_VF = ($DB_CX->DbResult(0,2)=="O") ? true : false;
    $tcMenu = ($tcMenu=="") ? $DB_CX->DbResult(0,3) : $tcMenu;
    $USER_SUBSTITUE = $DB_CX->DbResult(0,4);
    $SEMAINE_TYPE = $DB_CX->DbResult(0,5);
    $FILTRE_COULEUR = $DB_CX->DbResult(0,6);
    // Vrification de la substitution
    $DB_CX->DbQuery("SELECT util_id FROM ${PREFIX_TABLE}utilisateur LEFT JOIN ${PREFIX_TABLE}planning_partage ON ppl_util_id=util_id WHERE (util_id=".$USER_SUBSTITUE." AND util_partage_planning='1') OR (util_id=".$USER_SUBSTITUE." AND util_partage_planning='2' AND ppl_consultant_id=".$idUser.")");
    if (!$DB_CX->DbNumRows()) {
      $USER_SUBSTITUE = $idUser;
      $majSubst = ", sid_util_subst_id=".$idUser;
    }
    // Bail ok, on le renouvelle
    $DB_CX->DbQuery("UPDATE ${PREFIX_TABLE}sid SET sid_last_maj=now()".$majSubst." WHERE sid_id='".$idSession."'");
  }
  else {
    Header("location: deconnexion.php?msg=5");
    exit;
  }

  return ($idUser);
}


// ----------------------------------------------------------------------------
function jourFerie($annee,&$Paques,&$Ascension,&$Pentecote,$format="j-m") {
  if (function_exists("easter_date")) {
    //un jour en secondes 
    $jour = 3600*24;

    $Paques = date($format, easter_date($annee)+$jour);
    $Ascension = date($format, easter_date($annee)+39*$jour);
    //if ($annee<2004)
    $Pentecote = date($format, easter_date($annee)+50*$jour);
  }
}


//-------------------------------------------
function calcJour($place, $jour, $mois, $annee) {
  if ($place < 4) {
    $debScan = 1+$place*7;
    $finScan = 8+$place*7;
    for ($i=$debScan;$i<$finScan;$i++)
      if ($jour == date("w",mktime(12,0,0,$mois,$i,$annee))) return $i;
  }
  else {
    $debScan = date("t",mktime(12,0,0,$mois,1,$annee));
    $finScan = $debScan - 7;
    for ($i=$debScan;$i>$finScan;$i--)
      if ($jour == date("w",mktime(12,0,0,$mois,$i,$annee))) return $i;
  }
}


// ----------------------------------------------------------------------------
function rfcDate() {
  $tn = time(0);
  $zone = gmdate("H", $tn) * 60 + gmdate("i", $tn);
  $julian = gmdate("z", $tn);
  $t = getdate($tn);
  $zone = $t["hours"] * 60 + $t["minutes"] - $zone;
  if ($julian = $t["yday"] - $julian) {
    $zone += (($julian < 0) == (abs($julian) == 1)) ? -24*60 : 24*60;
  }
  $zone_sign = ($zone > 0 ? "+" : "-");
  return date('D, d M Y H:i:s ', $tn).$zone_sign.sprintf("%02d%02d", abs($zone)/60, abs($zone)%60)." (".strftime("%Z").")"; 
}


// ----------------------------------------------------------------------------
function quote_printable($str,$WithCharset) {
  $str = str_replace("%","=",rawurlencode($str));
  return "=?${WithCharset}?Q?${str}?=";
}


// ----------------------------------------------------------------------------
function enteteMail($expediteurNom,$expediteurMail) {
  $Charset = "iso-8859-1";
  $expediteurNom = quote_printable($expediteurNom,$Charset);
  $mailDate = rfcDate();
  $Headers = "From: ".$expediteurNom." <".$expediteurMail.">\n";
  $Headers .= "X-Sender: <".$expediteurMail.">\n";
  $Headers .= "X-Mailer: PHP/".phpversion()."\n";
  $Headers .= "Return-Path: <".$expediteurMail.">\n";
  $Headers .= "Date: ".$mailDate."\n";
  $Headers .= "Mime-Version: 1.0\n";
  $Headers .= "Content-Type: text/html; charset=".$Charset."\n";
  return $Headers;
}


// ----------------------------------------------------------------------------
function signatureMail() {
  global $APPLI_VERSION;
  $signature = "\n\n<CENTER><HR size=\"1\" color=\"#000000\">";
  $signature .= "<FONT color=\"gray\" size=\"-1\">Mail automatique g&eacute;n&eacute;r&eacute; par Phenix ".$APPLI_VERSION." [<A href=\"http://www.phenix.gapi.fr\"><FONT color=\"black\">phenix.gapi.fr</FONT></A>]</FONT></CENTER>\n</BODY></HTML>\n";
  return $signature;
}


// ----------------------------------------------------------------------------
  function envoiMail($mailEmetteur,$destMail,$sujetMail,$corpsMail) {
    global $SMTP_SERVER, $SMTP_PORT, $SMTP_LOGIN, $SMTP_PASSWORD, $APPLI_VERSION;
    global $classMailerLoaded,$classSMTPLoaded, $mailer;
    $envoiOK = false;
    if (function_exists("mail") && !$classMailerLoaded) {
      $iniSMTP = ini_get('SMTP');
      if (empty($iniSMTP)) {
        ini_set("SMTP", $SMTP_SERVER);
        ini_set("smtp_port", $SMTP_PORT);
      }
      $envoiOK = @mail(implode(",", $destMail), $sujetMail, $corpsMail, enteteMail("Phenix ".$APPLI_VERSION,$mailEmetteur));
    }
    if (!$envoiOK) {
      if (!$classMailerLoaded) {
        $mailer = new Mailer();
        $classMailerLoaded = true;
        if (!empty($SMTP_SERVER)) {
          $mailer->use_smtp($SMTP_SERVER, $SMTP_PORT, $SMTP_LOGIN, $SMTP_PASSWORD);
          $classSMTPLoaded = true;
        }
      } else
        $mailer->clear_all();
      $mailer->set_from($mailEmetteur, "Phenix ".$APPLI_VERSION);
      for ($i=0;$i<count($destMail);$i++)
        $mailer->set_address($destMail[$i]);
      $mailer->set_format('html'); 
      $mailer->set_subject($sujetMail); 
      $mailer->set_message($corpsMail); 
      $envoiOK = $mailer->send();
    }
    return $envoiOK;
  }


// ----------------------------------------------------------------------------
function genrePrenom($lettre) {
  $tabVoyelle = array("a","e","i","o","u","y");
  $ok = false;
  for ($i=0;$i<count($tabVoyelle) && !$ok;$i++)
    $ok = ($tabVoyelle[$i] == $lettre);
  return ($ok) ? "d'" : "de ";
}


// ----------------------------------------------------------------------------
// Permet de trouver le prochain indice de colonne o la tranche horaire change
// de statut (occup ou libre)
// Rinitialise dans le mme temps le tableau des tranches horaires
function colSpan($hDeb,$flag) {
  global $aJournee, $iDureeJournee;
  for ($i=$hDeb;$i<$iDureeJournee;$i++) {
    if ($aJournee[$i][0]!=$flag)
      return $i;
    $aJournee[$i][0]=0;
  }
  return $i;
}
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
  function afficheHeure($heure,$minute) {
    return date("H:i",mktime($heure,($minute*60)%60,0,1,1,2000));
  }
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
  function infoPopUp($text) {
    return " onmouseover=\"javascript: atc('".addslashes($text)."'); return false;\" onmouseout=\"javascript: nd(); return true;\"";
  }
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
  function afficheAge($date,$jourCrt) {
    $tabDate = explode("-",$date);
    $age=date("Y",$jourCrt)-$tabDate[0];
    if (date("md",$jourCrt)<($tabDate[1].$tabDate[2]))
      $age--;
    $text = ($age>0) ? "Age : <B>".$age." an".(($age>1) ? "s" : "")."</B> (".$tabDate[2]."/".$tabDate[1]."/".$tabDate[0].")" : "Jour de naissance";
    return infoPopUp($text);
  }
// ----------------------------------------------------------------------------
?>